import QtQuick 2.7
import QtQuick.Controls 2.0
import QtQuick.Window 2.2
import QtQuick.Layouts 1.3
import QtQuick.Controls.Material 2.0

Page {
    GridView {
        width: 800; height: parent.height;
        cellWidth: 200; cellHeight: 100
        anchors.centerIn: parent
        model: categoryModel
        delegate: Pane {
            width: 160; height: 80
            background: Rectangle {
                border.color: "#e2e2e2"
                border.width: 2
                radius: 5
            }
            Text {
                width: parent.width; height: parent.height
                clip: true
                elide: Text.ElideMiddle
                wrapMode: Text.WordWrap
                font.pixelSize: 24
                text: name
                color: "#525252"
//                anchors.horizontalCenter: parent.horizontalCenter
                anchors.centerIn: parent

                MouseArea {
                    anchors.fill: parent
                    onPressed: {
                        productModel.onGetProduct(parent.text)
                        pageCategory.visible = false
                        pageProduct.visible = true
                        returnMenu.visible = true
                    }
                }
            }
        }
    }
}
