import QtQuick 2.6
import QtQuick.Controls 2.0
import QtQuick.Window 2.2
import QtQuick.Layouts 1.3
import QtQuick.Controls.Material 2.0

Page {
    width: parent.width; height: parent.height
    GridView {
        width: 840; height: parent.height
        cellWidth: 210; cellHeight: 260
        anchors.centerIn: parent
        model: productModel
        delegate: Pane {
            width: 200
            background: Rectangle {
                border.color: "#e2e2e2"
                border.width: 2
                radius: 5
            }
            Column {
                width: parent.width
                anchors.horizontalCenter: parent.horizontalCenter
                Rectangle {
                    width: 100
                    height: 100
                    color: "#525252"
                    anchors.horizontalCenter: parent.horizontalCenter
                }
                Text {
                    width: parent.width
                    text: name
                    clip: true
                    color: "#525252"
                    anchors.horizontalCenter: parent.horizontalCenter
                }
                Text {
                    text: unit
                    color: "#525252"
                }
                Row {
                    Text {
                        text: qsTr("Осталось: ")
                        color: "#525252"
                    }
                    Text {
                        id: rem
                        text: remainder
                        color: "#525252"
                    }
                }
                Item {
                    width: parent.width; height: 30
                    Text {
                        anchors.left: parent.left
                        text: price
                        font.pixelSize: 24
                        anchors.horizontalCenter: parent.horizontalCenter
                        Component.onCompleted: {
                            text = Math.round(parseFloat(text)*100)/100 + qsTr(" \u20BD")
                        }
                    }
                    Row {
                        anchors.right: parent.right
                        anchors.verticalCenter: parent.verticalCenter
                        Button {
                            width: 20; height: 20
                            Text {
                                text: qsTr("-")
                                anchors.centerIn: parent
                                color: "#525252"
                            }
                            onPressed: {
                                if (countText.text > 1) countText.text--
                            }
                        }
                        Rectangle {
                            width: 30; height: 20
                            border.color: "#e2e2e2"
                            border.width: 1
                            TextEdit {
                                id: countText
                                text: qsTr("1")
                                anchors.centerIn: parent
                                color: "#525252"
                                inputMethodHints: Qt.ImhDigitsOnly
                                Keys.onReturnPressed: {
                                    if (parseInt(rem.text) >= parseInt(countText.text)) {
                                        countText.focus = false;
                                    }
                                    else {
                                        countText.text = rem.text;
                                        countText.focus = false;
                                        pushWindow("Превышено количество имеющегося на складе товара", 0, true, 2500);
                                    }
                                }
                            }
                        }
                        Button {
                            width: 20; height: 20
                            Text {
                                text: qsTr("+")
                                anchors.centerIn: parent
                                color: "#525252"
                            }
                            onPressed:  {
                                var temp = countText.text
                                if (rem.text > temp++) countText.text++
                            }
                        }
                    }
                }
                Button {
                    width: parent.width; height: 40
                    background: Rectangle { color: "#ffdd37" }
                    Text {
                        text: qsTr("В КОРЗИНУ")
                        anchors.centerIn: parent
                        font.pixelSize: 24

                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                if (parseInt(rem.text) >= parseInt(countText.text))
                                    productModel.onProductAddedToBasket(name, countText.text);
                                else {
                                    countText.text = rem.text;
                                    countText.focus = false;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
